var machineInfo = require('./global')
var checksum = require('./checksum')

module.exports = {
  conTest: function () {
    let data = [];
    data.push(0x3a);
    data.push(0);
    data.push(0);
    data.push(0xc6);
    return Buffer(data);
  },
  socketPressReset: function () {
    let data = [];
    let snLength = machineInfo.sn.length;
    data.push(0x3a);
    data.push(1);
    data.push(snLength);
    data = data.concat(machineInfo.sn);
    console.log(data)
    let checkSum = checksum(data);
    data.push(checkSum);
    return Buffer(data);
  },
  beginScan: function () {
    let data = [];
    let snLength = machineInfo.sn.length;
    data.push(0x3a);
    data.push(2);
    data.push(snLength);
    data = data.concat(machineInfo.sn);
    let checkSum = checksum(data);
    data.push(checkSum);
    return Buffer(data);
  },
  stopScan: function () {
    let data = [];
    let snLength = machineInfo.sn.length;
    data.push(0x3a);
    data.push(3);
    data.push(snLength);
    data = data.concat(machineInfo.sn);
    let checkSum = checksum(data);
    data.push(checkSum);
    return Buffer(data);
  },
  reStartScan:function () {
      let data = [];
      let snLength = machineInfo.sn.length;
      data.push(0x3a);
      data.push(5);
      data.push(snLength);
      data = data.concat(machineInfo.sn);
      let checkSum = checksum(data);
      data.push(checkSum);
      return Buffer(data);
  },
  // 关闭软件时发送协议 通知对方关闭
  closeShoesServer:function(){
      let data = [];
      let snLength = machineInfo.sn.length;
      data.push(0x3a);
      data.push(9);
      data.push(snLength);
      data = data.concat(machineInfo.sn);
      let checkSum = checksum(data);
      data.push(checkSum);
      return Buffer(data);
  },
  // 检查相机
  checkCamera:function () {
      let data = [];
      let snLength = machineInfo.sn.length;
      data.push(0x3a);
      data.push(10);
      data.push(snLength);
      data = data.concat(machineInfo.sn);
      let checkSum = checksum(data);
      data.push(checkSum);
      return Buffer(data);
  }
}